#!/usr/bin/python

import bluetooth, sys, dbus, dbus.glib, threading, os, subprocess, re, gui, gtk, time
import c



class bt_dbus:

	def __init__(self):
		self.bus = dbus.SystemBus();
		self.obj = self.bus.get_object('org.bluez', '/org/bluez/hci0')
		self.adapter = dbus.Interface(self.obj, 'org.bluez.Adapter')
		
		
		#self.bus.add_signal_receiver(self.bonding_created_signal, 'BondingCreated', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/hci0')

	
class Inquiry():
	def __init__(self, hci, callback):
		
		self.bus = dbus.SystemBus();
		self.obj = self.bus.get_object('org.bluez', '/org/bluez/'+hci)
		self.adapter = dbus.Interface(self.obj, 'org.bluez.Adapter')
				
		
		self.bus.add_signal_receiver(self.disc_started_signal, 'DiscoveryStarted', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)
		self.bus.add_signal_receiver(self.rem_dev_found_signal, 'RemoteDeviceFound', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)
		self.bus.add_signal_receiver(self.disc_completed_signal, 'DiscoveryCompleted', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)
		self.bus.add_signal_receiver(self.on_remote_name_updated, 'RemoteNameUpdated', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)
		self.bus.add_signal_receiver(self.on_RemoteNameFailed, 'RemoteNameFailed', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)

		#self.bus.remove_signal_receiver(self.disc_started_signal, 'org.bluez.Adapter', 'org.bluez', '/org/bluez/hci0')
		
		self.hci = hci
		self.callback = callback
		self.active = False
		self.dev_count = 0
		
		
	def Deinit(self):
		self.bus.remove_signal_receiver(self.disc_started_signal, 'DiscoveryStarted', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+self.hci)
		self.bus.remove_signal_receiver(self.rem_dev_found_signal, 'RemoteDeviceFound', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+self.hci)
		self.bus.remove_signal_receiver(self.disc_completed_signal, 'DiscoveryCompleted', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+self.hci)
		self.bus.remove_signal_receiver(self.on_remote_name_updated, 'RemoteNameUpdated', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)
		self.bus.remove_signal_receiver(self.on_RemoteNameFailed, 'RemoteNameFailed', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)
	
	def CancelDiscovery(self):
		self.adapter.CancelDiscovery()
		self.active = False
	
	
	def StartInquiry(self):
		#main_list.set_row_by_address("Test")
		main_list.reset()
		self.adapter.DiscoverDevices();
		
		toolbar.disable_buttons()
		toolbar.inquiry1.set_sensitive(True)
		toolbar.set_icon(toolbar.inquiry1, IMAGE_DIR + "/stop.png")
		toolbar.inquiry1.set_label(_("Cancel"))

		self.devices = []
		self.active = True
		self.dev_count = 0
		
		Statusbar.inquiry_start()
	
	
	def on_remote_name_updated(self, address, name):
		#print "RemoteNameUpdated:" + address, name
		cache = c.cache("cache")
		main_list.edit_row(address, name)
		cache.push(address, name)
		
	def on_RemoteNameFailed(self, address):
		main_list.edit_row(address)
		
		cache = c.cache("cache")
		old = cache.pull(address)
		if not old:
			cache.push(address, "N/A")
		#print "on_RemoteNameFailed" + address
	
	def disc_started_signal(self):
		#self.inq_progress = gui.inquiry_progress()
        	print 'Signal: DiscoveryStarted()'

	def rem_dev_found_signal(self,address, cls, rssi):
	       # print 'Signal: RemoteDeviceFound(%s, %s, %s)' % (address, cls, rssi)
	       
	       # if address in self.addresses:
		if not address in self.devices:
			#print "add"
			self.dev_count += 1
	       		self.devices.append(address)
	       		main_list.add_from_list([[address, "Updating..."]], False)
	       		Statusbar.push(_("Found %s Device(s)") % main_list.row_count)
	        
	        

	def disc_completed_signal(self):
	        print 'Signal: DiscoveryCompleted()'
		Statusbar.inquiry_finish()


		self.active = False
		toolbar.set_icon(toolbar.inquiry1, IMAGE_DIR + "/inquiry.png")
		toolbar.inquiry1.set_label(_("Inquiry"))

	
		
		

		

class Connectivity():
	def __init__(self, hci, callback):
		
		self.bus = dbus.SystemBus();
		
		self.bus.add_signal_receiver(self.device_connected_signal, 'RemoteDeviceConnected', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)
		self.bus.add_signal_receiver(self.device_disconnected_signal, 'RemoteDeviceDisconnected', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)	
		
		self.callback = callback
		
		self.connections = []
		
		self.hci = hci
		
	
	def Deinit(self):
		self.bus.remove_signal_receiver(self.device_connected_signal, 'RemoteDeviceConnected', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+self.hci)
		self.bus.remove_signal_receiver(self.device_disconnected_signal, 'RemoteDeviceDisconnected', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+self.hci)
	

	
	def device_connected_signal(self, addr):
		self.connections.append(addr)
		self.callback((True, addr))
		
		
	
	
	def device_disconnected_signal(self, addr):
		self.connections.remove(addr)
		self.callback((False, addr))
		
		
		
			
		
		
		
		
				
				
import dbus.service
import time				
			
			
#bus = dbus.SystemBus();
#obj = bus.get_object('org.bluez', '/org/bluez/hci0')
#adapter = dbus.Interface(obj, 'org.bluez.Security')

#adapter.RegisterDefaultPasskeyAgent("/org/bluez/blueman")

class Adapter():
	
	def __init__(self, device):
		
		self.bus = dbus.SystemBus();
		self.obj = self.bus.get_object('org.bluez', '/org/bluez/'+device)
		self.adapter = dbus.Interface(self.obj, 'org.bluez.Adapter')
	
	
	def ListPorts(self):
		return self.adapter.ListPorts()
		
	def GetRemoteServices(self,addr,name=None,uuid=None):
		
		return bluetooth.find_service(name=name, uuid=name, address=addr)	
	
	def GetRemoteServiceClasses(self,addr):
		return self.adapter.GetRemoteServiceClasses(addr)
	
	def GetDiscoverableTimeout(self):
		return self.adapter.GetDiscoverableTimeout()
		
	def SetDiscoverableTimeout(self, timeout):
		self.adapter.SetDiscoverableTimeout(dbus.UInt32(timeout))

	
	#-----------local device functions--------------------#
	
	
	def ListAvailableMinorClasses(self):
		return self.adapter.ListAvailableMinorClasses()
	
	def GetAddress(self):
		return self.adapter.GetAddress();
	
	def GetMinorClass(self):
		return self.adapter.GetMinorClass();
		
	def SetMinorClass(self, minor):
		self.adapter.SetMinorClass(minor)
	
	def GetMajorClass(self):
		return self.adapter.GetMajorClass()
		

	
	def GetMode(self):
		return self.adapter.GetMode()
		
	def SetMode(self, mode):
		self.adapter.SetMode(mode)
		
	def ListAvailableModes(self):
		return self.adapter.ListAvailableModes()
		
	
	def GetAddress(self):
		return self.adapter.GetAddress()
		
	def GetVersion(self):
		return self.adapter.GetVersion()
		
	def GetRevision(self):
		return self.adapter.GetRevision()
		
	def GetCompany(self):
		return self.adapter.GetCompany()
		
	
	def GetManufacturer(self):
		return self.adapter.GetManufacturer()

			
	def GetName(self):
		return self.adapter.GetName()
		
	def SetName(self, name):
		self.adapter.SetName(name)
		
	def IsConnectable(self):
		return self.adapter.IsConnectable()
		
	def ListRemoteDevices(self):
		return self.adapter.ListRemoteDevices()
		
		
	def ListConnections(self):
		return self.adapter.ListConnections()
		
	def ListBondings(self):
		return self.adapter.ListBondings()
		
	def is_valid_address(self, addr):
		return bluetooth.is_valid_address(addr)
		

		
		
		
#-----------remote device functions--------------------#
	
	
	    

	
	
	def CancelBondingProcess(self, addr):

		handle = self.adapter.RemoveBonding(addr)
		return True
		
			
	def HasBonding(self,addr):
		if(self.adapter.HasBonding(addr)):
			return True
		else:
			return False

			
	def GetRemoteVersion(self, addr):
		return self.adapter.GetRemoteVersion(addr)
		

		
	def IsConnected(self, addr):
		return self.adapter.IsConnected(addr)
		

	def GetRemoteName(self,addr):
		#print "name request for %s" % addr
		cache = c.cache("cache")
		cname = cache.pull(addr)
		if cname:
			#print "found %s in cache" % cname
			#print "-------------------"
			return cname
		else:
			#print "name not in cache. Asking hcid"
			try:
				
				name = self.adapter.GetRemoteName(addr)
				#print "hcid returned %s, caching" % name
				cache.push(addr, name)
				#print "-------------------"
				return name
				
			
			except:
				#print "hcid doesn't know, caching 'N/A'"
				cache.push(addr, "N/A")
				#print "-------------------"
				return "N/A"
		

		
	def GetRemoteMinorClass(self, addr):

		return self.adapter.GetRemoteMinorClass(addr)
		
	def GetRemoteMajorClass(self, addr):

		return self.adapter.GetRemoteMajorClass(addr)
		
	def GetRemoteRevision(self, addr):
		return self.adapter.GetRemoteRevision(addr)
		
	def GetRemoteManufacturer(self, addr):
		return self.adapter.GetRemoteManufacturer(addr)
	
	def GetRemoteCompany(self, addr):
		return self.adapter.GetRemoteCompany(addr)
	
	def LastUsed(self,addr):
		return self.adapter.LastUsed(addr)

		
	def LastSeen(self, addr):
		return self.adapter.LastSeen(addr)
	

		
	def GetRemoteAlias(self,addr):

		return self.adapter.GetRemoteAlias()

	
	def get_signal_strength(self, addr):

		pipe = subprocess.Popen("hcitool lq " + addr, shell=True, stdout=subprocess.PIPE).stdout
		data = pipe.read()
		
		result = ""
		if len(data) == 0:
			return 0
		else:
			data = str(data)
			data = data.split(":")
			
			
			for i in range(len(data[1])):
				
				if re.match("[0-9]",data[1][i]):
					result = result + data[1][i]
			
			if not len(result) <= 3:
				raise Exception

			
			
			
			#print 
			
			
			return float(result)*100/255



class Bonding():
	
	def __init__(self, hci, callback):
		
		self.bus = dbus.SystemBus();
		self.obj = self.bus.get_object('org.bluez', '/org/bluez/'+hci)
		self.adapter = dbus.Interface(self.obj, 'org.bluez.Adapter')
		
		self.hci = hci
		self.bus.add_signal_receiver(self.bonding_created_signal, 'BondingCreated', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+hci)
		
		self.callback = callback
		
	def Deinit(self):
		self.bus.remove_signal_receiver(self.bonding_created_signal, 'BondingCreated', 'org.bluez.Adapter', 'org.bluez', '/org/bluez/'+self.hci)
		
		
	def bonding_created_signal(self,bdaddr):
       		self.BondingReturn((True,bdaddr))

	
	def Create(self,addr):
		self.adapter.CreateBonding(addr, reply_handler=self.BondingReply, error_handler=self.BondingError)
		return True
		
	
	def BondingReply(self):
		pass
		
	
	def BondingError(self,err):
		self.BondingReturn((False,err))
		
	
	def BondingReturn(self, result):
		self.callback(result)
		
	
	def Remove(self,addr):
		handle = self.adapter.RemoveBonding(addr)
		return True
		
	


class PasskeyAgent(dbus.service.Object):
	def __init__(self, path):

		
		self.bus = dbus.SystemBus();
		
		
		#self.obj = self.bus.get_object('org.bluez', '/org/bluez/hci0')

		dbus.service.Object.__init__(self, self.bus, path)
		self.registered=False

	def register(self):
		#def bla(self):
			
			 
		pipe = subprocess.Popen('ps -A | grep "bluetooth-appl"', shell=True, stdout=subprocess.PIPE).stdout
		data = pipe.read()
		if len(data) > 0:
			#print "a"
			if not Settings.replace_agent_by_default:
				q = gui.question_box()
				res =  q.run()
			else:
				res = True
			
			if res:
				os.system("killall bluetooth-applet")
			else:
				return 0
		
		
		
		self.obj = self.bus.get_object('org.bluez', '/org/bluez/hci0')
		security = dbus.Interface(self.obj, 'org.bluez.Security')
		security.RegisterDefaultPasskeyAgent("/org/bluez/blueman")
		self.registered=True


        @dbus.service.method(dbus_interface='org.bluez.PasskeyAgent')
        
	def Complete(self, *args):
		print "Complete"
		#print args
        
        
        @dbus.service.method(dbus_interface='org.bluez.PasskeyAgent')
        
	def Request(self, *args):

		gtk.gdk.threads_enter()
		Notification.show(_("Bonding request"),_("Bonding Request For %(addr)s (%(name)s)") % {"addr": args[1], "name": adapter.GetRemoteName(args[1]) }, im="bond_bt.png" )
		Statusbar.push(_("Connected. Waiting for passkey"))
		dialog = gui.bond_dialog(args[1], adapter.GetRemoteName(args[1]))
		
		if dialog.run():
			passkey = dialog.get()
			Statusbar.push(_("Passkey sent. Waiting for confirmation"))
			dialog.destroy()
		else:
			dialog.destroy()
			Statusbar.push(_("Bonding Cancelled"))
			gtk.gdk.threads_leave()
			raise dbus.DBusException("org.bluez.Error.Canceled")
			
			return 0
		
		gtk.gdk.threads_leave()
		return passkey
		
	
	@dbus.service.method(dbus_interface='org.bluez.PasskeyAgent')
        
	def Confirm(self, *args):
		print "confirm"
		#print args
		
	
	
	@dbus.service.method(dbus_interface='org.bluez.PasskeyAgent')
        
	def Cancel(self, *args):
		print "cancel"
		#print args
		


class rfcomm_config_parser:
	
	def __init__(self, filename):
	
		try:
			self.fp = open(filename, "rw")
			#print self.fp.readline()
			in_section = False
			
			self.rfcomm = []
			
			data = [0,False,"00:00:00:00:00",0,""]
			
			for line in self.fp:
				
				if re.match("^rfcomm[0-9]* {$",line) and not in_section:
					#print line
					in_section = True
					#print scanf.sscanf(line, "rfcomm%d {")
					data[0] = int(re.search("[a-zA-Z]([0-9]*).{$",line).group(1))
				
				if re.match("^\t[a-zA-Z0-9]",line) and in_section:
					#spl = line.split(" ")
					res = re.match("[ \t]*([a-zA-Z0-9]*)[ \t](.*).$",line)
					#print res.groups()
					if res.group(1) == "bind":
						if res.group(1) == "no":
							data[1] = False
						else:
							data[1] = True
							
					if res.group(1) == "device":
						data[2] = res.group(2)
						
					if res.group(1) == "channel":
						data[3] = int(res.group(2))
						
					if res.group(1) == "comment":
						data[4] = res.group(2).replace('"',"")
						
							
			
				
				if re.match("^}",line) and in_section:
					in_section = False
					self.rfcomm.append(data)
					data = [0,False,"00:00:00:00:00",0,""]
				
		except:
			self.rfcomm = []
		
		
	def get_section(self, sect):
		
		for i in range(len(self.rfcomm)):
			if self.rfcomm[i][0] == sect:
				return self.rfcomm[i]
				
	def edit_section(self, sect, bind, device, channel, comment):
		for i in range(len(self.rfcomm)):
			if self.rfcomm[i][0] == sect:
				self.rfcomm[i][1] = bind
				self.rfcomm[i][2] = device
				self.rfcomm[i][3] = channel
				self.rfcomm[i][3] = comment
				
				
	def add_section(self, chan, bind, device, channel, comment):
		temp = [chan, bind, device, channel, comment]
		self.rfcomm.append(temp)
				
	def del_section(self, sect):
		for i in range(len(self.rfcomm)):
			if self.rfcomm[i][0] == sect:
				del self.rfcomm[i]
				break
				
	def get_sections(self):
		return self.rfcomm
		
		
	def get_cond(self, index, match):
		
		data = []
		
		for i in range(len(self.rfcomm)):
			
			if self.rfcomm[i][index] == match:
				data.append(self.rfcomm[i])
				
		return data
		
	def save(self):
		
		fp = open("/tmp/rfcomm","w")
		
		lines = []
		
		for i in range(len(self.rfcomm)):
			lines.append("rfcomm"+ str(self.rfcomm[i][0]) + " {\n")
			
			if self.rfcomm[i][1]:			
				lines.append("\tbind yes;\n")
			else:
				lines.append("\tbind no;\n")
				
			
			lines.append("\tdevice "+ self.rfcomm[i][2] + ";\n")
			lines.append("\tchannel "+ str(self.rfcomm[i][3]) + ";\n")
			lines.append("\tcomment \""+ self.rfcomm[i][4] + "\";\n")
			lines.append("}\n")
			lines.append("\n")
			
		fp.writelines(lines)
		
		os.system("gksudo 'mv /tmp/rfcomm /etc/bluetooth/rfcomm.conf -f'")



class Manager():
				
	def __init__(self, callback):
		self.bus = dbus.SystemBus();
		self.obj = self.bus.get_object('org.bluez', '/org/bluez')
		self.manager = dbus.Interface(self.obj, 'org.bluez.Manager')
		
		self.bus.add_signal_receiver(self.on_adapter_added, 'AdapterAdded', 'org.bluez.Manager', 'org.bluez', '/org/bluez')
		self.bus.add_signal_receiver(self.on_adapter_removed, 'AdapterRemoved', 'org.bluez.Manager', 'org.bluez', '/org/bluez')
		
		self.callback = callback
		
	def ListAdapters(self):
		return self.manager.ListAdapters()
		
	def DefaultAdapter(self):
		return self.manager.DefaultAdapter()
		
	
	def on_adapter_added(self, path):
		self.callback(True, path)
	
	
	def on_adapter_removed(self, path):
		self.callback(False, path)
		

class PAN():
	
	def __init__(self):
		

		
		self.role = ""
		
		self.interface = "bnep0"
		self.devup = "" 
		self.devdown = ""
		
		self.host = ""
		
		self.auth = False
		self.encrypt = False
		self.secure = False
		
		self.panu_running = False
		
		self.autostart = False

		
		self.daemon_start_callback= None
		self.daemon_stop_callback = None
		self.status_callback = None
		
		self.config = c.config("services")
		
		if self.load_settings():
			if self.autostart:
				self.status_callback = self.global_status
				if not self.daemon_status() and (self.role == "GN" or self.role == "NAP"):
					self.start_daemon()
					
				elif self.get_connections() == 0 and self.role == "PANU":
					self.start_daemon()

	
	
	
	
	def global_status(self, msg):
		print msg
	
	
	def save_settings(self):
		self.config.refresh()
		self.config.add("pan.autostart", int(self.autostart))
		self.config.add("pan.host",self.host)
		self.config.add("pan.ifup",self.devup)
		self.config.add("pan.ifdown", self.devdown)
		self.config.add("pan.role", self.role)
		self.config.add("pan.interface", self.interface)
		self.config.add("pan.auth", int(self.auth))
		self.config.add("pan.secure", int(self.secure))
		self.config.add("pan.encrypt", int(self.encrypt))
		self.config.save()
	
	def load_settings(self):
		try:
			self.autostart = int(self.config.get_option("pan.autostart"))
			self.host = self.config.get_option("pan.host")
			self.devdown = self.config.get_option("pan.ifdown")
			self.devup = self.config.get_option("pan.ifup")
			self.role = self.config.get_option("pan.role")
			self.interface = self.config.get_option("pan.interface")
			
			self.auth = int(self.config.get_option("pan.auth"))
			self.encrypt = int(self.config.get_option("pan.encrypt"))
			self.secure = int(self.config.get_option("pan.secure"))
			return True
		except:
			return False
			
		
		

		
	
	
	def get_connections(self):
		
		pipe = subprocess.Popen('pand --list', shell=True, stdout=subprocess.PIPE).stdout
		conns = []
		for line in pipe:
			addr = line.split(" ")[1]
			name = adapter.GetRemoteName(addr)
			iface = line.split(" ")[0]
			conns.append([addr, name, iface])
			
		return conns
	

	
	def validation_thread(self):
		self.status_callback(_("<b>Validating</b>"))
		for i in range(10):	

			if self.role == "PANU":	
				if len(self.get_connections()) >= 1:
					self.status_callback(_("<b>PANU Active</b>"))
					try:
						self.daemon_start_callback()
					except:
						pass
					return 1
					
			else:
				if self.daemon_status:
					self.status_callback(_("<b>Active</b>"))
					try:
						self.daemon_start_callback()
					except:
						pass
					return 1
					
			time.sleep(1)
		
		self.daemon_stop_callback()
					
	def launch_thread(self):
		self.status_callback("<b>Starting Daemon</b>")
		args = self.get_args()
		os.system("gksudo 'pand %(listen)s %(connect)s %(role)s %(master)s %(interface)s %(devup)s %(devdown)s %(auth)s %(secure)s %(encrypt)s'" % args)
		threading.Thread(target=self.validation_thread, args=()).start()
	
	
	def service_check_thread(self):
		self.status_callback(_("<b>Checking Services</b>"))
		services = adapter.GetRemoteServices(self.host)
		for i in range(len(services)):
			sclass = services[i]["service-classes"][0]
			if sclass == bluetooth.NAP_CLASS or sclass == bluetooth.GN_CLASS:

				threading.Thread(target=self.launch_thread, args=()).start()
				return 1
	
		
		self.status_callback(_("<b>No PAN services available</b>"))
		time.sleep(1)
		self.daemon_stop_callback()

	
	
	def start_daemon(self):
		if self.role == "PANU":
			self.status_callback("<b>Starting PANU</b>")
			threading.Thread(target=self.service_check_thread, args=()).start()
		else:
			self.status_callback("<b>Starting NAP/GN</b>")
			threading.Thread(target=self.launch_thread, args=()).start()		

		self.save_settings()
			
		
			
			
	def stop_daemon(self):
		os.system("gksudo 'pand --killall' ")
		os.system("gksudo 'killall pand'")

		if self.panu_running:
			self.panu_running = False
			try:
				self.daemon_stop_callback()
			except:
				pass
				
			return True

		time.sleep(0.1)
		if not self.daemon_status():

			try:
				self.daemon_stop_callback()
			except:
				pass
			
			return True
		
		else:
			return False


	def daemon_status(self):
		pipe = subprocess.Popen('ps -A | grep "pand"', shell=True, stdout=subprocess.PIPE).stdout
		data = pipe.read()
		if len(data) == 0:
			return False
		else:
			return True
			
	
	def kill_connection(self, addr):
		os.system("gksudo 'pand --kill %s'" % addr)
		#time.sleep(0.2)
		#connections = self.get_connections()
		#for i in range(len(connections)):
		#	if connections[i][0] == addr:
		#		return False
				
		#return True
			
		
	def kill_all_connections(self):
		os.system("gksudo 'pand --killall'")
		time.sleep(0.2)
		connections = self.get_connections()
		if len(connections) > 0:
			return False
			
		return True
		
	
	
	def get_args(self):
		arg_auth = ""
		arg_encrypt = ""
		arg_secure = ""
		
		if self.role == "GN" or self.role == "NAP":
			arg_listen = "--listen"
			arg_connect = ""
			arg_master = "--master"
			
			if self.auth:
				arg_auth = "--auth"
				
			if self.secure:
				arg_secure = "--secure"

			if self.encrypt:
				arg_encrypt = "--encrypt"		
		
		
		else:
			arg_listen = ""
			arg_connect = "--connect %s" % self.host
			arg_master = ""
			
			

		arg_role = "--role %s" % self.role
		

		if not self.interface == "":
			arg_interface = "--ethernet %s" % self.interface
		else:
			arg_interface = ""
		
		
		if not self.devup == "":
			arg_devup = "--devup %s" % self.devup
		else:
			arg_devup = ""
		
		
		if not self.devdown == "":
			arg_devdown = "--devdown %s" % self.devdown
		else:
			arg_devdown = ""
		
		args = 	{
		
		"listen" : arg_listen,
		"connect" : arg_connect,
		"role" : arg_role,
		"master" : arg_master,
		"auth" : arg_auth,
		"secure" : arg_secure,
		"encrypt" : arg_encrypt,
		"interface" : arg_interface,
		"devup" : arg_devup,
		"devdown" : arg_devdown

		}
		
		return args
		


class obex:
	def __init__(self):
		self.config = c.config("services")
		self.autostart = False
		self.load_settings()
		
		if self.autostart:
			if not self.status():
				self.start()
				print "starting"
	
	def save_settings(self):
		self.config.refresh()
		self.config.add("obex.autostart", int(self.autostart))
		self.config.save()
	
	def load_settings(self):
		try:
			self.autostart = int(self.config.get_option("obex.autostart"))
			return True
		except:
			return False
			
	def status(self):
		pipe = subprocess.Popen('ps -A | grep "gnome-obex"', shell=True, stdout=subprocess.PIPE).stdout
		data = pipe.read()
		if len(data) == 0:
			return False
		else:
			return True

	def start(self):
		os.system("gnome-obex-server &")
		
	def stop(self):
		os.system("killall gnome-obex-server")
				
		
class sco:
	
	def __init__(self):
		pass
		
	
	def status(self):
		pipe = subprocess.Popen('ps -A | grep "btsco"', shell=True, stdout=subprocess.PIPE).stdout
		data = pipe.read()
		if len(data) == 0:
			return False
		else:
			return True

	def start(self, dev):
		os.system('gksudo "modprobe snd_bt_sco"')
		os.system('gksudo "btsco %s" &' % dev)
		
	def stop(self):
		os.system('gksudo "killall btsco"')
		os.system('gksudo "rmmod snd_bt_sco"')
