#!/usr/bin/env python
import os
import gtk
import gtk.glade
import threading
import time
import gobject
import pynotify
import bt
import pango

#gtk.gdk.threads_init()


import locale
import gettext
gettext.bindtextdomain('blueman', '/usr/share/blueman/locale')
gettext.textdomain('blueman')

_ = gettext.gettext




class main_window():
	
	def __init__(self, xml):
		
		self.xml = xml
		self.window = self.xml.get_widget("window1");
		self.window.set_title(_("Bluetooth Manager") + " 0.1.9");
		self.window.set_icon_from_file(IMAGE_DIR + "/bluetooth.png")
		self.page = ""
		
		headset = xml.get_widget("headset")
		im = gtk.Image()
		im.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size(IMAGE_DIR + "/devices/handsfree.png",16, 16))
		headset.set_image(im)
		
		if not Settings.open_in_tray:
				self.show()
		
		
		
	def set_handler(self, event, func):	
		self.xml.signal_connect(event,func)
		
		
	def show(self):
		self.window.show()
		
	def hide(self):
		self.window.hide()
		
	def visible(self):
		return self.window.get_property("visible")
			

	



class toolbar():
	def __init__(self, xml):
		
		self.xml = xml
		self.inquiry1 = self.xml.get_widget("inquiry1")
		self.listseen1 = self.xml.get_widget("listseen1")
		self.bond1 = self.xml.get_widget("bond1")
		self.addfav1 = self.xml.get_widget("addfav1")
		self.properties1 = self.xml.get_widget("properties1")
		self.sendfile1 = self.xml.get_widget("sendfile1")
		self.browse1 = self.xml.get_widget("browse1")
		self.mydevice1 = self.xml.get_widget("mydevice1")
		self.favourites1 = self.xml.get_widget("favourites1")
		
		self.set_icon(self.inquiry1,IMAGE_DIR + "/inquiry.png");
		self.set_icon(self.listseen1,IMAGE_DIR + "/listseen.png");
		self.set_icon(self.bond1,IMAGE_DIR + "/bond.png");
		self.set_icon(self.addfav1,IMAGE_DIR + "/addfav.png");
		self.set_icon(self.properties1,IMAGE_DIR + "/properties.png");
		self.set_icon(self.sendfile1,IMAGE_DIR + "/sendfile.png");
		self.set_icon(self.browse1,IMAGE_DIR + "/browse.png");
		self.set_icon(self.mydevice1,IMAGE_DIR + "/mydevice.png");
		self.set_icon(self.favourites1,IMAGE_DIR + "/favs.png");
		
		
	def enable_buttons(self):
		self.bond1.set_sensitive(True)
		self.addfav1.set_sensitive(True)
		self.properties1.set_sensitive(True)
		self.sendfile1.set_sensitive(True)
		self.browse1.set_sensitive(True)
		
	def disable_buttons(self):
		self.bond1.set_sensitive(False)
		self.addfav1.set_sensitive(False)
		self.properties1.set_sensitive(False)
		self.sendfile1.set_sensitive(False)
		self.browse1.set_sensitive(False)
		
	def set_icon(self, button, filename):
		image = gtk.Image()
		image.set_from_file(filename)
		image.show()
		button.set_icon_widget(image)
		
	def disable_all_buttons(self):
		self.bond1.set_sensitive(False)
		self.addfav1.set_sensitive(False)
		self.properties1.set_sensitive(False)
		self.sendfile1.set_sensitive(False)
		self.browse1.set_sensitive(False)
		self.inquiry1.set_sensitive(False)
		self.listseen1.set_sensitive(False)
		self.favourites1.set_sensitive(False)
		self.mydevice1.set_sensitive(False)

	def enable_main_buttons(self):
		self.inquiry1.set_sensitive(True)
		self.listseen1.set_sensitive(True)
		self.favourites1.set_sensitive(True)
		self.mydevice1.set_sensitive(True)
		
	def set_handler(self, event, func):	
		self.xml.signal_connect(event,func)




class CellRendererCustom(gtk.GenericCellRenderer):
	__gproperties__ = {
		"pixbuf": (gobject.TYPE_OBJECT, "pixbuf", "pixbuf", gobject.PARAM_READWRITE),
		"progress": (gobject.TYPE_INT, "Progress", "progress", 0, 100, 0, gobject.PARAM_READWRITE),
	}

	def __init__(self):
		self.__gobject_init__()

                

	def do_set_property(self, pspec, value):
			setattr(self, pspec.name, value)

	def do_get_property(self, pspec):
			return getattr(self, pspec.name)

	def on_render(self, window, widget, background_area,cell_area, expose_area, flags):
		if not self.pixbuf:
			return
		
		gc = widget.window.new_gc()
		#gc.background.red, gc.background.green, gc.background.blue = 0,0,0
		gc.foreground.red, gc.foreground.green, gc.foreground.blue = 65535,65535,65535

		context = widget.get_pango_context()
		layout  = widget.create_pango_layout(str(self.progress)+'%')
		desc = pango.FontDescription('sans bold 8')


		layout.set_font_description(desc)  

		
		pix_rect = gtk.gdk.Rectangle()
		pix_rect.x, pix_rect.y, pix_rect.width, pix_rect.height = self.on_get_size(widget, cell_area)

		
		pix_rect.x += cell_area.x
		pix_rect.y += cell_area.y
		pix_rect.width  -= 2 * self.get_property("xpad")
		pix_rect.height -= 2 * self.get_property("ypad")

		draw_rect = cell_area.intersect(pix_rect)
		draw_rect = expose_area.intersect(draw_rect)
		
		#print draw_rect.x, draw_rect.y+2
		
		#print draw_rect.x-pix_rect.x, draw_rect.y-pix_rect.y, draw_rect.x, draw_rect.y+2, draw_rect.width, draw_rect.height
		#print self.progress

		#fore = gtk.gdk.Color(65535,65535,65535)

		
		window.draw_pixbuf(widget.style.black_gc, self.pixbuf, draw_rect.x-pix_rect.x, draw_rect.y-pix_rect.y, draw_rect.x, draw_rect.y+2, draw_rect.width, draw_rect.height,   gtk.gdk.RGB_DITHER_NONE, 0, 0)
		window.draw_layout(widget.style.fg_gc[0], draw_rect.x, draw_rect.y+38, layout)

	def on_get_size(self, widget, cell_area):
		if not self.pixbuf:
			return 0, 0, 0, 0

		pixbuf_width  = self.pixbuf.get_width()
		
		pixbuf_height = self.pixbuf.get_height()
		calc_width  = self.get_property("xpad") * 2 + pixbuf_width
		calc_height = self.get_property("ypad") * 2 + pixbuf_height
		x_offset = 0
		y_offset = 0
		
		if cell_area and pixbuf_width > 0 and pixbuf_height > 0:
			x_offset = self.get_property("xalign") * (cell_area.width - calc_width -  self.get_property("xpad"))
			y_offset = self.get_property("yalign") * (cell_area.height - calc_height -  self.get_property("ypad"))
		#print x_offset, y_offset, calc_width, calc_height
		return x_offset, y_offset, calc_width, calc_height

gobject.type_register(CellRendererCustom)



class main_list():
	
	def __init__(self, xml):
		
		self.xml = xml

		#main text, last seen text, b
		self.liststore = gtk.ListStore(str,str,str,str,'GdkPixbuf', 'GdkPixbuf', 'GdkPixbuf',bool,bool,int)
		self.treeview = self.xml.get_widget("list");


		self.treeview.set_model(self.liststore);


		self.tvcolumn = gtk.TreeViewColumn('Pixbuf and Text')


		self.treeview.append_column(self.tvcolumn)


		self.cellpb1 = gtk.CellRendererPixbuf()
		#self.cellpb2 = gtk.CellRendererText()
		self.cellpb2 = CellRendererCustom()
		self.cellpb3 = gtk.CellRendererPixbuf()
		self.cellpb4 = gtk.CellRendererPixbuf()

		self.cell = gtk.CellRendererText()
		self.cell2 = gtk.CellRendererText()




		self.tvcolumn.pack_start(self.cellpb1, False)
		self.tvcolumn.pack_start(self.cell, True)
		self.tvcolumn.pack_start(self.cell2, True)
		#self.tvcolumn.pack_start(self.cell2, True)


		#self.tvcolumn.pack_start(self.cell3, False)




		self.tvcolumn.pack_start(self.cellpb2, False)
		self.tvcolumn.pack_start(self.cellpb3, False)




		self.tvcolumn.set_attributes(self.cell, markup=0)
		self.tvcolumn.set_attributes(self.cell2, markup=1)

		self.tvcolumn.set_attributes(self.cellpb1, pixbuf=4)
		self.tvcolumn.set_attributes(self.cellpb2, pixbuf=5, progress=9)
		self.tvcolumn.set_attributes(self.cellpb3, pixbuf=6)
		# self.tvcolumn.set_attributes(self.cell3, value=9, visible=10)

		self.row_count = 0
		


	def add(self, 
			pixbuf=None, 
			devtype="cellular",
			connected=True, 
			bonded=True, 
			address="00:00:00:00:00",
			name="unknown",
			lastseen=False):
		
		#print "add_item"
		
		
		if pixbuf == None:
		
			pixbuf = gtk.gdk.pixbuf_new_from_file(IMAGE_DIR + "/bluetooth.png");
		
		self.buffs = [None,None]

		
		if bonded:
			
			self.buffs[0] = gtk.gdk.pixbuf_new_from_file(IMAGE_DIR + "/hasbonding.png");

		elif connected:
			self.buffs[1] = gtk.gdk.pixbuf_new_from_file(IMAGE_DIR + "/signal/0.svg");



		
		
		if not lastseen:
			lastseen = ""
		else:
			lastseen = "<span size='8000' rise='-40000' weight='light'><b>Last Seen:</b> " + lastseen + "</span>"
		
		
		iter = self.liststore.append(
			[_("<b>Name:</b>") + " " + name + _("\n<b>Device type:</b>") + " " + devtype + _("\n<b>Address:</b>") + " " +address,
			lastseen, 
			address, 
			name, 
			pixbuf,
			self.buffs[1],
			self.buffs[0],
			connected,
			bonded,
			0]);
			
		self.row_count=self.row_count+1
		
		if connected:
			if not address in Connectivity.connections:
				Connectivity.connections.append(address)
			
			threading.Thread(target=signals.update_signal, args=(iter, address,)).start()		


		
	
	def edit_row(self, addr, name="N/A", dev_class=False):
		for i in range(len(self.liststore)):	
			iter = self.liststore[i].iter
			data = self.liststore.get(iter, 0, 1, 2, 3)
			if data[2] == addr:
				#print data[2]
				if not dev_class:
					dev_class = adapter.GetRemoteMinorClass(addr)
				text = _("<b>Name:</b> %(name)s\n<b>Device type:</b> %(type)s\n<b>Address:</b> %(addr)s" ) % {"name":name,"type":dev_class,"addr":addr}
				
				self.set_data(iter, 0, text)
	
	

		
	
	def reset(self):
		self.row_count = 0
		self.liststore.clear();
		
		
	def get_iter_by_row(self, rowid):
		try:
			return self.liststore.get_iter_from_string(str(rowid))
		except:
			return None
	
	
	def get_selected_row(self):
		rowid = self.treeview.get_cursor()
		try:
			return self.get_row(rowid[0][0])
		except:
			return None
	
	def get_row(self, rowid):
		iter = self.get_iter_by_row(str(rowid))
		bdaddr = self.liststore.get(iter,2)
		name = self.liststore.get(iter,3)
		isbond = self.liststore.get(iter,8)
		isconn = self.liststore.get(iter,7)

		return (bdaddr[0], name[0], isconn[0], isbond[0], iter)
		
		
	def set_pixbuf(self, iter, col, icon):
		if not icon == None:
			pb = gtk.gdk.pixbuf_new_from_file(IMAGE_DIR + "/" + icon);
		else:
			pb = None
			
		self.liststore.set(iter, col, pb)
		
	def set_data(self, iter, col, data):
			
		self.liststore.set(iter, col, data)
		
	
	def set_handler(self, event, func):	
		self.xml.signal_connect(event,func)
		
	
	def add_from_list(self, src, show_lastseen=True):
		#self.reset()
		for i in range(len(src)):
			#name = bt.GetRemoteName(test[i])
			name = src[i][1]
			
			try:
				devtype = adapter.GetRemoteMinorClass(src[i][0])
			except:
				devtype = _("unknown")
				
			
			if show_lastseen:
				try:	
					lastseen = adapter.LastSeen(src[i][0])
				except:
					lastseen = _("unknown")
			else:
				lastseen = False
				
			try:
				connected = adapter.IsConnected(src[i][0])
			except:
				connected = False
				
			try:
				bonded = adapter.HasBonding(src[i][0])
			except:
				bonded = False
			
			
			if not os.path.exists(IMAGE_DIR + "/devices/" + str(devtype) + ".png"):
				pb = gtk.gdk.pixbuf_new_from_file(IMAGE_DIR + "/bluetooth.png")
			else:
				pb = gtk.gdk.pixbuf_new_from_file(IMAGE_DIR + "/devices/" + str(devtype) + ".png")
			
			self.add(pb, devtype, connected, bonded, src[i][0].upper(), name, lastseen)
			
		Statusbar.push(_("Listed %s device(s)") % self.row_count)
			
			#self.statusbar.push(self.context_id,_("Listed %s device(s)") % str(self.list_row_count))
			
			
			

	
	
		
		
		
#----------------------------------------------




class question_box():

	def __init__(self):	
	
		self.glade = gtk.glade.XML(GLADE_DIR + "/question_dialog.glade")
		self.glade.signal_autoconnect(self)
		self.label = self.glade.get_widget("label1")
		self.dialog = self.glade.get_widget("question_dialog")
		
	
	def set_text(self, text):
		self.label.set_text(text)
		
	def run(self):
	
		response = self.dialog.run()

		if response == gtk.RESPONSE_OK:
			self.dialog.destroy()
			return True
		
		elif response == gtk.RESPONSE_CANCEL:
			self.dialog.destroy()
			return False
			
			
class inquiry_progress():
	
	def __init__(self):
		
		self.glade = gtk.glade.XML(GLADE_DIR + "/inquiry_progress.glade")
		self.glade.signal_autoconnect(self)
		
		self.progress_win = self.glade.get_widget("inquiry_progress");
		self.pbar = self.glade.get_widget("progressbar1");
		
		self.image1 = self.glade.get_widget("image1");
		self.image1.set_from_file(IMAGE_DIR + "/bluetooth.png")
		self.image1.show()
		
		self.progress = 0 

		self.timer = gobject.timeout_add (100, self.animate)
		
		
	
	
	#def onCancel(self):
	
	
	
	def animate(self):
		self.pbar.pulse()
		self.progress += 0.009803922
		if self.progress > 1:
			self.progress = 1
		self.pbar.set_fraction(self.progress)
		return True
	

	

		
	def Destroy(self):
		
		gobject.source_remove(self.timer)
		self.progress_win.destroy()




class StatusIcon:
	
	def __init__(self, xml):
		
		self.status_icon = gtk.StatusIcon()
		self.status_icon.set_from_file(IMAGE_DIR + "/bluetooth.png")
		self.status_icon.set_tooltip(_("Blueman - Bluetooth Manager"))
		
		self.status_icon.connect('activate', self.tray_toggle)
		self.status_icon.connect('popup-menu', self.tray_popup)
		
		xml = xml
		self.window = xml.get_widget("window1");
	
	
	
	def tray_toggle(self, tray):
		
		
		
		if not window.visible():
			self.window.show()
		else:
			self.window.hide()
			
	def on_notifications_activate(self, widget):
		if Settings.connection_notifications:
			Settings.connection_notifications = False
			widget.set_active(False)
		else:
			Settings.connection_notifications = True
			widget.set_active(True)
			
		Settings.save()
		
	def on_other_notifications_activate(self, widget):
		if Settings.other_notifications:
			Settings.other_notifications = False
			widget.set_active(False)
		else:
			Settings.other_notifications = True
			widget.set_active(True)
			
		Settings.save()
			
	def tray_popup(self, status_icon, button, activate_time):

		menu = gtk.Menu()
		
		item = gtk.CheckMenuItem(_("Enable Connection Notifications"))
		menu.append(item)
		item.show()
		if Settings.connection_notifications:
			item.set_active(True)
		else:
			item.set_active(False)
			
		item.connect("toggled", self.on_notifications_activate)
		
		item = gtk.CheckMenuItem(_("Enable Other Notifications"))
		
		
		if Settings.other_notifications:
			item.set_active(True)
		else:
			item.set_active(False)
			
		item.connect("toggled", self.on_other_notifications_activate)

		
		
		menu.append(item)
		item.show()
		
		item = gtk.SeparatorMenuItem()
		menu.append(item)
		item.show()
		

		item = gtk.ImageMenuItem(_("_Quit"))
		img = gtk.image_new_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_MENU)
		item.set_image(img)
		item.connect("activate", signals.on_window_quit)
		menu.append(item)
		item.show()

		
		menu.popup( None, None, None, button, activate_time)

	def get_geometry(self):
		rect = self.status_icon.get_geometry()[1]
		x = rect.x
		y = rect.y
		w = rect.width
		h = rect.height
		return (x,y,w,h)
		
		
class Notification:
	def __init__(self, si):
		pynotify.init( "Blueman - Bluetooth Manager" )
		self.si = si	
			
	def show(self, header, text, time = 5000, im="bluetooth.png"):
		geo = self.si.get_geometry()

		n = pynotify.Notification(header, text, IMAGE_DIR + "/" + im)
		n.set_hint("x", geo[0]+geo[2]/2)
		n.set_hint("y", geo[1]+geo[3])
		n.set_urgency(pynotify.URGENCY_NORMAL)
		n.set_timeout(time)
		#n.add_action("clicked","Button text", self.test, None)
		n.show()
		
	

		
		
class Properties:
	
	def __init__(self):	
	
		
		self.xml = gtk.glade.XML(GLADE_DIR + "/properties.glade")
		self.xml.signal_autoconnect(self)

		self.dialog = self.xml.get_widget("properties");
		self.dialog.set_icon_from_file(IMAGE_DIR + "/properties.png")

		im = self.xml.get_widget("image3");
		im.set_from_file(IMAGE_DIR + "/services.png")

		im = self.xml.get_widget("image4");
		im.set_from_file(IMAGE_DIR + "/properties16.png")

		im = self.xml.get_widget("image1");
		im.set_from_file(IMAGE_DIR + "/gear.png")

		im = self.xml.get_widget("image2");
		im.set_from_file(IMAGE_DIR + "/com.png")


		but = self.xml.get_widget("button5");
		im = gtk.Image()
		im.set_from_file(IMAGE_DIR + "/del.png")
		but.set_image(im)

		but = self.xml.get_widget("button3");
		im = gtk.Image()
		im.set_from_file(IMAGE_DIR + "/inquiry16.png")
		but.set_image(im)

		but = self.xml.get_widget("button4");
		im = gtk.Image()
		im.set_from_file(IMAGE_DIR + "/bind.png")
		but.set_image(im)

		#--- comport list 

		self.comport_treeview = self.xml.get_widget("treeview2");

		self.comport_list = gtk.ListStore(str,str,str,int)
		self.comport_treeview.set_model(self.comport_list)


		cell = gtk.CellRendererText()

		tvcolumn = gtk.TreeViewColumn(_('Device'))
		tvcolumn2 = gtk.TreeViewColumn(_('Service'))
		tvcolumn3 = gtk.TreeViewColumn(_('Channel'))


		self.comport_treeview.append_column(tvcolumn)
		self.comport_treeview.append_column(tvcolumn2)
		self.comport_treeview.append_column(tvcolumn3)


		tvcolumn.pack_start(cell, True)
		tvcolumn2.pack_start(cell, True)
		tvcolumn3.pack_start(cell, True)

		tvcolumn.set_attributes(cell, markup=0)
		tvcolumn2.set_attributes(cell, markup=1)	
		tvcolumn3.set_attributes(cell, markup=2)


		#-- service list

		self.service_treeview = self.xml.get_widget("treeview1");

		self.service_list = gtk.ListStore(str,str)
		self.service_treeview.set_model(self.service_list)


		cell = gtk.CellRendererText()


		tvcolumn = gtk.TreeViewColumn(_('Name'))
		tvcolumn2 = gtk.TreeViewColumn(_('Channel'))

		self.service_treeview.append_column(tvcolumn)
		self.service_treeview.append_column(tvcolumn2)

		tvcolumn.pack_start(cell, True)
		tvcolumn2.pack_start(cell, True)

		tvcolumn.set_attributes(cell, markup=0)
		tvcolumn2.set_attributes(cell, markup=1)


		#---
		button = self.xml.get_widget("button3");
		button.set_sensitive(True)
		button.set_label(_("Get Service List"))

		lversion = self.xml.get_widget("label16");
		lrevision = self.xml.get_widget("label17");
		lmanufacturer = self.xml.get_widget("label18");
		lcompany = self.xml.get_widget("label19");
		lmajorclass = self.xml.get_widget("label20");
		lminorclass = self.xml.get_widget("label21")
		ldevname = self.xml.get_widget("label22")
		ldevaddress = self.xml.get_widget("label23");
		llastseen = self.xml.get_widget("label24");
		llastused = self.xml.get_widget("label25");
		lbonded = self.xml.get_widget("label26");
		lconnected = self.xml.get_widget("label27");


		addr = main_list.get_selected_row()[0]
		
		
			
		try:	
			version = adapter.GetRemoteVersion(addr)
			lversion.set_label(version)
		except:
			lversion.set_label(_("Not available"))
		
		
		try:
			connected = adapter.IsConnected(addr)
			if connected:
				lconnected.set_label(_("Yes"))
			else:
				lconnected.set_label(_("No"))
		except:
			lconnected.set_label(_("Not available"))
		
		try:
			name = adapter.GetRemoteName(addr)
			ldevname.set_label(name)
		except:
			ldevname.set_label(_("Not available"))
		
		try:
			minorclass = adapter.GetRemoteMinorClass(addr)
			lminorclass.set_label(minorclass)
		except:
			lminorclass.set_label(_("Not available"))
			
			
		try:
			majorclass = adapter.GetRemoteMajorClass(addr)
			lmajorclass.set_label(majorclass)
		except:
			lmajorclass.set_label(_("Not available"))
		
		try:
			manufacturer = adapter.GetRemoteManufacturer(addr)
			lmanufacturer.set_label(manufacturer)
		except:
			lmanufacturer.set_label(_("Not available"))
		
		try:
			lastseen = adapter.LastSeen(addr)
			llastseen.set_label(lastseen)
		except:
			llastseen.set_label(_("Not available"))
		
		try:
			lastused = adapter.LastUsed(addr)
			llastused.set_label(lastused)
		except:
			llastused.set_label("Not available")
		
		try:
			bonded = adapter.HasBonding(addr)
			if bonded:
				lbonded.set_label(_("Yes"))
			else:
				lbonded.set_label(_("No"))
		except:
			lbonded.set_label(_("Not available"))
		
		try:
			revision = adapter.GetRemoteRevision(addr)
			lrevision.set_label(revision)
		except:
			lrevision.set_label(_("Not available"))
		
		
		try:
			company = adapter.GetRemoteCompany(addr)
			lcompany.set_label(company)
			
		except:
			
			lcompany.set_label(_("Not available"))

		

		ldevaddress.set_label(addr)
		
		
		#self.comport_list.clear()
		
		
		list = RFCOMM.get_cond(2,addr)
		
		for i in range(len(list)):
			self.comport_list.append(["/dev/rfcomm"+str(list[i][0]),list[i][4],list[i][3],list[i][0]])
		
	
	def set_text(self, text):
		self.label.set_text(text)
		
	def run(self):
	
		response = self.dialog.run()
		if response == gtk.RESPONSE_CLOSE:
			self.dialog.destroy()
			return True
		
		elif response == gtk.RESPONSE_HELP:
			self.dialog.destroy()
			return False
			
		else:			
			self.dialog.destroy()
			return False
			

	
	def on_get_service_list_clicked(self, button):

		self.service_list.clear()
		threading.Thread(target=self.get_service_list_thread, args=(main_list.get_selected_row()[0],self.get_service_list,)).start()
		
		button = self.xml.get_widget("button3");
		button.set_sensitive(False)
		button.set_label(_("Please wait..."))
		
		

	def get_service_list_thread(self, addr,func):
		services = adapter.GetRemoteServices(addr)
		if not services:
			func(False)
		if main_list.get_selected_row()[0] == addr:
			func(services)			
		
		
	def get_service_list(self, services):
		button = self.xml.get_widget("button3");
		button.set_sensitive(True)
		button.set_label(_("Get Service List"))
		
		if not services:
			Statusbar.push(_("Failed to get service list"))
			return 0
		

		for i in range(len(services)):
			if services[i]["name"] and services[i]["port"]:
			       	self.service_list.append([services[i]["name"],services[i]["port"]])
			       	
			       	
	
	
	
	def on_unbind_com_port_clicked(self, button):

		rowid = self.comport_treeview.get_cursor()
		if rowid != None:

			iter = self.comport_list.get_iter_from_string(str(rowid[0][0]))
			id = self.comport_list.get(iter,3)
			self.comport_list.remove(iter)
			
			RFCOMM.del_section(id[0])
			RFCOMM.save()
	
	
	def on_bind_com_port(self, button):

	
		rowid = self.service_treeview.get_cursor()
		if rowid != None:
			
			iter = self.service_list.get_iter_from_string(str(rowid[0][0]))
			channel = self.service_list.get(iter,1)
			servname = self.service_list.get(iter,0)
			
			
			
			sections = RFCOMM.get_sections()
			used = []
			for i in range(len(sections)):
				used.append(sections[i][0])
			
			used = set(used)

			
			devsel = Device_selector()
			
			
			devsel.comport_bind_list.clear()
			for i in range(32):
						
				if not i in used:
					devsel.comport_bind_list.append(["/dev/rfcomm<b>"+str(i)+"</b>",i])

			
			devsel.comport_bind_combobox.set_active(0) 


			
			if devsel.run():
				port = devsel.get_selected()
				
				bdaddr = main_list.get_selected_row()[0]
				
				RFCOMM.add_section(port[0], True, bdaddr, channel[0], servname[0])
				RFCOMM.save()
				
				self.comport_list.append(["/dev/rfcomm"+str(port[0]),servname[0],channel[0],port[0]])
				
				devsel.destroy()
			else:
				devsel.destroy()


class Device_selector:
	
	def __init__(self):
		
		self.xml = gtk.glade.XML(GLADE_DIR + "/dev_selection.glade")
		self.xml.signal_autoconnect(self)
		
		self.dialog = self.xml.get_widget("selection");
		#self.dialog.set_icon_from_file(IMAGE_DIR + "/properties.png")
		
		self.comport_bind_combobox = self.xml.get_widget("combobox1");
		self.comport_bind_list = gtk.ListStore(str, int)
		self.comport_bind_combobox.set_model(self.comport_bind_list)
		
		cell = gtk.CellRendererText()
		self.comport_bind_combobox.pack_start(cell, True)
		self.comport_bind_combobox.add_attribute(cell, 'markup', 0) 
			
		
		
	def run(self):
		
		response = self.dialog.run()
		
		if response == gtk.RESPONSE_OK:
			

			return True
		else:
			return False
			
	def destroy(self):
		self.dialog.destroy()
		
	def get_selected(self):
		iter = self.comport_bind_combobox.get_active_iter()
		port = self.comport_bind_list.get(iter,1)
		return port
		
		
		
class bond_dialog:
	
	def __init__(self, addr, name):
		
		self.xml = gtk.glade.XML(GLADE_DIR + "/bonding.glade")
		self.xml.signal_autoconnect(self)
		
		self.dialog = self.xml.get_widget("bond_dialog");
		self.toggle = self.xml.get_widget("checkbutton1");
		self.text = self.xml.get_widget("entry1");
		
		self.name = self.xml.get_widget("name");
		self.addr = self.xml.get_widget("address");
		
		self.okbutton = self.xml.get_widget("okbutton1");
		
		self.name.set_label("<b>" + name + "</b>")
		self.addr.set_label("<i>" + addr + "</i>")
		
		image = self.xml.get_widget("image1");
		image.set_from_file(IMAGE_DIR + "/hasbonding.png")
		
		
	def on_input_toggled(self, checkbox):
		if self.toggle.get_active():
			self.text.set_visibility(True)
		else:
			self.text.set_visibility(False)
			
	def on_passkey_changed(self, widget):
		if len(widget.get_text()) > 0:
			self.okbutton.set_sensitive(True)
		else:
			
			self.okbutton.set_sensitive(False)
			
	def get(self):
		return self.text.get_text()
	
	
	def run(self):
	
		response = self.dialog.run()
		if response == gtk.RESPONSE_OK:
			
			return True
	
		else:			
			
			return False
			
	def passkey(self):
		return 
			
	def destroy(self):
		self.dialog.destroy()
		
		
class Statusbar:
	
	def __init__(self, cid, xml):
		
		self.statusbar = xml.get_widget("statusbar1");
		
		self.context_id = self.statusbar.get_context_id(cid)
		
		
		self.progeress_bar = gtk.ProgressBar()
		
		
		
		self.label = gtk.Label()
		
		self.hbox = gtk.HBox()
		self.hbox.pack_start(self.label,False,False)
		self.hbox.pack_start(self.progeress_bar,False,False)
		
		#self.hbox.show_all()

		self.statusbar.pack_start(self.hbox,False, False)
		
		self.progeress_bar.set_size_request(100, 10)
		
		self.progress = 0
		
		
	def inquiry_start(self):
		self.push(_("No devices found"))
		self.progress = 0
		self.progeress_bar.set_fraction(0)
		self.hbox.show_all()
		self.label.set_text("Scanning... ")
		self.timer = gobject.timeout_add (100, self.animate)
	
	
	def inquiry_finish(self):
		gobject.source_remove(self.timer)
		self.hbox.hide_all()
		
		
	def animate(self):
		if window.page != "inquiry":
			print "Cancel inquiry"
			CInquiry.CancelDiscovery()
		
		self.progress += 0.009803922
		if self.progress > 1:
			self.progeress_bar.pulse()
			self.label.set_text("Resolving Names... ")
		else:
			self.progeress_bar.set_fraction(self.progress)
		
		return True
	
		

	
	def push(self, text):
		self.statusbar.push(self.context_id, text)
		
	
	def pop(self):
		self.statusbar.pop(self.context_id)
		
		
class Settings_dialog:
	
	def __init__(self):
		
		self.xml = gtk.glade.XML(GLADE_DIR + "/preferences.glade")
		
		
		self.dialog = self.xml.get_widget("prefs")
		
		
		self.checkbutton1 = self.xml.get_widget("checkbutton1")
		self.checkbutton2 = self.xml.get_widget("checkbutton2")
		self.checkbutton3 = self.xml.get_widget("checkbutton3")
		self.checkbutton4 = self.xml.get_widget("checkbutton4")
		self.checkbutton5 = self.xml.get_widget("checkbutton5")
		self.checkbutton6 = self.xml.get_widget("checkbutton6")
		self.combo = self.xml.get_widget("combobox1")
		
		

		
		self.liststore = gtk.ListStore(str)
		self.combo.set_model(self.liststore)
		
		cell = gtk.CellRendererText()
		self.combo.pack_start(cell, True)
		self.combo.add_attribute(cell, 'markup', 0) 
		
		#self.connection_notifications=True
		#self.other_notifications=True
		#self.close_to_tray=False
		#self.open_in_tray=False
		#self.passkey_agent=True
		#self.replace_agent_by_default=True
		#Settings.passkey_agent=False
		
		
		if Settings.connection_notifications:
			self.checkbutton3.set_active(True)
	
		if Settings.other_notifications:
			self.checkbutton4.set_active(True)
			
		if Settings.close_to_tray:
			self.checkbutton1.set_active(True)
			
		if Settings.open_in_tray:
			self.checkbutton2.set_active(True)
			
		if Settings.passkey_agent:
			self.checkbutton5.set_active(True)
		else:
			self.checkbutton6.set_sensitive(False)
			
		if Settings.replace_agent_by_default:
			self.checkbutton6.set_active(True)
			
		adapters = Manager.ListAdapters()
		
		if len(adapters) == 0:
			self.combo.set_sensitive(False)
		
		for i in range(len(adapters)):
			 adapter = adapters[i].split("/")[3]
			 self.liststore.append([adapter])
			 #print adapter
			 #print Settings.adapter
			 if Settings.adapter == adapter:
			 	self.combo.set_active(i)
			 	
		self.xml.signal_autoconnect(self)
			 
		
			
			
	def on_checkbutton1_toggled(self, widget):
		if widget.get_active():
			Settings.close_to_tray=True
		else:
			Settings.close_to_tray=False
			
	def on_checkbutton2_toggled(self, widget):
		if widget.get_active():
			Settings.open_in_tray=True
		else:
			Settings.open_in_tray=False
			
	def on_checkbutton3_toggled(self, widget):
		if widget.get_active():
			Settings.connection_notifications=True
		else:
			Settings.connection_notifications=False
			
	def on_checkbutton4_toggled(self, widget):
		if widget.get_active():
			Settings.other_notifications=True
		else:
			Settings.other_notifications=False
			
			
	def on_checkbutton5_toggled(self, widget):
		if widget.get_active():
			Settings.passkey_agent=True
			self.checkbutton6.set_sensitive(True)
		else:
			Settings.passkey_agent=False
			self.checkbutton6.set_sensitive(False)
			
			
	def on_checkbutton6_toggled(self, widget):
		if widget.get_active():
			Settings.replace_agent_by_default=True
		else:
			Settings.replace_agent_by_default=False
		
		
	def on_combobox1_changed(self, widget):
		
		iter = self.combo.get_active_iter()
		dev = self.liststore.get(iter,0)
		Settings.adapter = dev[0]
		init_adapter(Settings.adapter)
		
	
	def run(self):
	
		response = self.dialog.run()
		Settings.save()
		if response == gtk.RESPONSE_CLOSE or gtk.RESPONSE_NONE:
			self.dialog.destroy()
			return False
	
		else:			
			self.dialog.destroy()
			return True
			
			
			
class about:
			
	def __init__(self):		
			
		self.xml = gtk.glade.XML(GLADE_DIR + "/about.glade")
		self.xml.signal_autoconnect(self)
		self.dialog = self.xml.get_widget("about")
		self.dialog.set_logo_icon_name("blueman")
		logo = gtk.gdk.pixbuf_new_from_file_at_size(IMAGE_DIR + "/logo.svg",192,192)
		self.dialog.set_logo(logo)
		self.run()
	
	def run(self):

	
		response = self.dialog.run()
		Settings.save()
		if response == gtk.RESPONSE_CLOSE or gtk.RESPONSE_NONE:
			self.dialog.destroy()
			return False
	
		else:			
			self.dialog.destroy()
			return True
			
			
			
class my_device:
			
	def __init__(self):		
			
		self.xml = gtk.glade.XML(GLADE_DIR + "/my_device.glade")
		self.xml.signal_autoconnect(self)
		self.dialog = self.xml.get_widget("mydevice")
		self.slider = self.xml.get_widget("hscale1")
		self.name = self.xml.get_widget("name")
		self.combobox = self.xml.get_widget("class")
		self.dialog.set_icon_from_file(IMAGE_DIR + "/bluetooth.png")
		
		
		im = self.xml.get_widget("image2");
		im.set_from_file(IMAGE_DIR + "/services.png")
		
		im = self.xml.get_widget("image1");
		im.set_from_file(IMAGE_DIR + "/properties16.png")
		
		timeout = adapter.GetDiscoverableTimeout()
		self.slider.set_value(timeout/60)
		
		self.dev_name = adapter.GetName()
		self.name.set_text(self.dev_name)
		
		#adapter.SetMinorClass("laptop")
		self.minor = adapter.GetMinorClass()
		
		
		
		self.liststore = gtk.ListStore(str, str)
		self.combobox.set_model(self.liststore)
		
		cell = gtk.CellRendererText()
		self.combobox.pack_start(cell, True)
		#self.combobox.add_attribute(cell, 'markup', 0) 
		
		
		
		self.liststore.append(["Desktop Computer","desktop"])
		self.liststore.append(["Laptop Computer","laptop"])
		self.liststore.append(["Server","server"])
		self.liststore.append(["Unspecified","uncategorized"])
		
		self.liststore.foreach(self.iter_func)
		
		self.limited = self.xml.get_widget("radiobutton4")
		self.discoverable = self.xml.get_widget("radiobutton1")
		self.connectable = self.xml.get_widget("radiobutton2")
		self.off = self.xml.get_widget("radiobutton5")
		
		self.mode = adapter.GetMode()
		
		try:
			self.modes = adapter.ListAvailableModes()
		except:
			self.limited.set_sensitive(False)
		
		if self.mode == "connectable":
			self.connectable.set_active(True)
			self.slider.set_sensitive(False)
		elif self.mode == "discoverable":
			self.discoverable.set_active(True)
		elif self.mode == "limited":
			self.limited.set_active(True)
		else:
			self.slider.set_sensitive(False)
			self.off.set_active(True)
		

		
		
		self.lbversion = self.xml.get_widget("label15")
		self.lrevision = self.xml.get_widget("label16")
		self.lmanufacturer = self.xml.get_widget("label17")
		self.lcompany = self.xml.get_widget("label19")
		self.lmajorclass = self.xml.get_widget("label18")
		self.lminorclass = self.xml.get_widget("label20")
		self.lname = self.xml.get_widget("label21")
		self.laddress = self.xml.get_widget("label27")
		
		try:
			self.lbversion.set_text(adapter.GetVersion())
		except:
			self.lbversion.set_text(_("Not Available"))
			
		try:
			self.lrevision.set_text(adapter.GetRevision())
		except:
			self.lrevision.set_text(_("Not Available"))
		
		try:
			self.lmanufacturer.set_text(adapter.GetManufacturer())
		except:
			self.lmanufacturer.set_text(_("Not Available"))
			
		try:
			self.lcompany.set_text(adapter.GetCompany())
		except:
			self.lcompany.set_text(_("Not Available"))
			
		try:
			self.lmajorclass.set_text(adapter.GetMajorClass())
		except:
			self.lmajorclass.set_text(_("Not Available"))

		try:
			self.lminorclass.set_text(adapter.GetMinorClass())
		except:
			self.lminorclass.set_text(_("Not Available"))

		try:
			self.lname.set_text(adapter.GetName())
		except:
			self.lname.set_text(_("Not Available"))	
			
		try:
			self.laddress.set_text(adapter.GetAddress())
		except:
			self.laddress.set_text(_("Not Available"))	
		
		
		
		self.run()
	
	
	
	def on_mode_toggled(self, button):
		if button.get_active():
			if button == self.limited:
				adapter.SetMode("limited")
			elif button == self.discoverable:
				self.slider.set_sensitive(True)
				adapter.SetMode("discoverable")
			elif button == self.connectable:
				self.slider.set_sensitive(False)
				adapter.SetMode("connectable")
			elif button == self.off:
				self.slider.set_sensitive(False)
				adapter.SetMode("off")
	
	
	def iter_func(self, model, path, iter):
		if model.get(iter,1)[0] == self.minor:
			self.combobox.set_active_iter(iter)
	
	
	def on_slider_changed(self, slider):
		time = int(slider.get_value())*60
		adapter.SetDiscoverableTimeout(time)

			
			
	def on_slider_format(self, slider, value):
		if value == 0:
			return _("Always Visible")
		return  _("%i Minute(s)") % value

		
	def on_class_changed(self, widget):
		newclass = self.liststore.get(widget.get_active_iter(),1)[0]
		adapter.SetMinorClass(newclass)

	
	
	def run(self):

	
		response = self.dialog.run()

		if not self.name.get_text() == self.dev_name:
			adapter.SetName(self.name.get_text())


		if response == gtk.RESPONSE_CLOSE or gtk.RESPONSE_NONE:
			self.dialog.destroy()
			return False
	
		else:			
			self.dialog.destroy()
			return True
			
			
			
class pan:
	def __init__(self):
		
		self.xml = gtk.glade.XML(GLADE_DIR + "/pan.glade")
		
		self.dialog = self.xml.get_widget("pan")
		
		self.l_ifup = self.xml.get_widget("l_ifup")
		self.e_ifup = self.xml.get_widget("e_ifup")
		
		self.cb_auto_start = self.xml.get_widget("cb_auto_start")
		
		self.l_host = self.xml.get_widget("l_host")
		self.e_host = self.xml.get_widget("e_host")
		
		self.e_interface = self.xml.get_widget("e_interface")
		
		self.b_start = self.xml.get_widget("b_start")
		self.b_stop = self.xml.get_widget("b_stop")
		
		self.rb_nap = self.xml.get_widget("rb_nap")
		self.rb_gn = self.xml.get_widget("rb_gn")
		self.rb_panu = self.xml.get_widget("rb_panu")
		
		self.cb_auth = self.xml.get_widget("cb_auth")
		self.cb_encrypt = self.xml.get_widget("cb_encrypt")
		self.cb_security = self.xml.get_widget("cb_security")
		
		self.l_ifdown = self.xml.get_widget("l_ifdown")
		self.e_ifdown = self.xml.get_widget("e_ifdown")
		self.l_interface = self.xml.get_widget("l_interface")
		self.l_daemon = self.xml.get_widget("l_daemon")
		
			
		
		#----- list------#
		
		
		
		
		self.conn_list = self.xml.get_widget("conn_list");

		self.liststore = gtk.ListStore(str, str, str)
		self.conn_list.set_model(self.liststore);


		self.tvcolumn = gtk.TreeViewColumn(_('Address'))
		self.tvcolumn2 = gtk.TreeViewColumn(_('Name'))
		self.tvcolumn3 = gtk.TreeViewColumn(_('Interface'))
					
		self.conn_list.append_column(self.tvcolumn)
		self.conn_list.append_column(self.tvcolumn2)
		self.conn_list.append_column(self.tvcolumn3)



		cell = gtk.CellRendererText()



		self.tvcolumn.pack_start(cell, True)
		self.tvcolumn2.pack_start(cell, True)
		self.tvcolumn3.pack_start(cell, True)

		self.tvcolumn.set_attributes(cell, markup=0)
		self.tvcolumn2.set_attributes(cell, markup=1)
		self.tvcolumn3.set_attributes(cell, markup=2)
		
		#self.liststore.append(["test1","test2", "Test3"])
		conns = self.refresh_connections()
		
		self.cb_auto_start.set_active(PAN.autostart)
		
	
		
		PAN.daemon_stop_callback = self.on_daemon_stop
		PAN.daemon_start_callback = self.on_daemon_start
		PAN.status_callback = self.on_status_changed
		
		
		self.e_ifup.set_text(PAN.devup)
		self.e_ifdown.set_text(PAN.devdown)
		
		if PAN.auth:
			self.cb_auth.set_active(True)
		
		if PAN.encrypt:
			self.cb_encrypt.set_active(True)
		
		if PAN.secure:
			self.cb_security.set_active(True)
			
		self.e_interface.set_text(PAN.interface)
		
		
		addr = main_list.get_selected_row()
		if addr:
			self.e_host.set_text(addr[0])
			PAN.host = addr[0]
			PAN.save_settings()
		else:
			self.e_host.set_text(PAN.host)
			
		#self.real_host = addr[0]
		
		
		
		self.xml.signal_autoconnect(self)
		
		if PAN.role == "NAP":
			self.rb_nap.set_active(True)
		elif PAN.role == "GN":
			self.rb_gn.set_active(True)
		elif PAN.role == "PANU":
			self.rb_panu.set_active(True)

		else:
			self.rb_nap.set_active(True)
			
		
		if PAN.daemon_status():
			self.disable_controls()
			if len(PAN.role) > 0:
				self.l_daemon.set_markup(_("<b>Active (%s)</b>") % PAN.role)
			else:
				self.l_daemon.set_markup(_("<b>Active</b>"))
			
			self.b_start.set_sensitive(False)
			self.b_stop.set_sensitive(True)
			
		else:
			if conns > 0:
				self.l_daemon.set_markup(_("<b>PANU Active</b>"))
				self.disable_controls()
				self.b_stop.set_sensitive(True)
				self.b_start.set_sensitive(False)
		
		self.dialog.show()
		res = self.dialog.run()
		self.dialog.destroy()
	
	def refresh_connections(self):
		self.liststore.clear()
		count = 0
		conns = PAN.get_connections()
		
		for i in range(len(conns)):
			self.liststore.append( conns[i] )
			count += 1
			
		return count		
	
	def on_NAP_toggled(self, widget):
		if widget.get_active():
			self.l_host.hide()
			self.e_host.hide()
			
			self.cb_encrypt.show()
			self.cb_auth.show()
			self.cb_security.show()
		
			self.b_start.set_sensitive(True)
			PAN.role="NAP"
			PAN.save_settings()

	
	def on_GN_toggled(self, widget):
		if widget.get_active():
			self.l_host.hide()
			self.e_host.hide()
			
			self.cb_encrypt.show()
			self.cb_auth.show()
			self.cb_security.show()	
					
			self.b_start.set_sensitive(True)
			PAN.role="GN"
			PAN.save_settings()
		
		
	def on_PANU_toggled(self, widget):
		if widget.get_active():
			
			self.l_host.show()
			self.e_host.show()
			
			self.cb_encrypt.hide()
			self.cb_auth.hide()
			self.cb_security.hide()
			
			if not adapter.is_valid_address(self.e_host.get_text()):
				self.b_start.set_sensitive(False)
			
			PAN.role="PANU"
			PAN.save_settings()

			
	def on_cb_auto_start(self, widget):
		if widget.get_active():
			PAN.autostart = True

		else:
			PAN.autostart = False
			
		PAN.save_settings()
			
	def on_e_ifup_changed(self, widget):
			
		PAN.devup=widget.get_text()
		PAN.save_settings()
			
			
		
	def on_e_interface_changed(self, widget):
		
		if len(self.e_interface.get_text()) == 0:
			self.b_start.set_sensitive(False)

		else:
			self.b_start.set_sensitive(True)
			
		PAN.interface=widget.get_text()
		PAN.save_settings()
		
	def on_e_ifdown_changed(self, widget):

		PAN.devdown=widget.get_text()
		PAN.save_settings()
		
	def on_e_host_changed(self, widget):
		PAN.host = widget.get_text()
		
		if not adapter.is_valid_address(widget.get_text()):
			self.b_start.set_sensitive(False)

		else:
			self.b_start.set_sensitive(True)
		PAN.save_settings()
		
		
	def on_cb_encrypt_toggled(self, widget):
		if widget.get_active():
			PAN.encrypt=True
		else:
			PAN.encrypt=False
		PAN.save_settings()

	
	def on_cb_auth_toggled(self, widget):
		if widget.get_active():
			PAN.auth=True
		else:
			PAN.auth=False
		PAN.save_settings()
		
	
	def on_cb_security_toggled(self, widget):
		if widget.get_active():
			PAN.secure=True
		else:
			PAN.secure=False
			
		#print PAN.secure
		PAN.save_settings()		
		
		
	def on_b_start_clicked(self, widget):
		PAN.save_settings()
		PAN.start_daemon()

		
	def on_b_stop_clicked(self, widget):
		PAN.stop_daemon()
		
		
	
			
	
	####### pan callbacks #########
	
	def on_status_changed(self, status):
		self.disable_controls()
		self.l_daemon.set_markup(status)
	
	
	
	def on_daemon_stop(self):
		self.l_daemon.set_markup(_("<b>Inactive</b>"))
		self.enable_all()
		self.b_stop.set_sensitive(False)	
		self.liststore.clear()
	
	
	def on_daemon_start(self):
		

		conns = self.refresh_connections()
		self.b_stop.set_sensitive(True)
		self.b_start.set_sensitive(False)
			

			

	#########################
			
		
		
	
	
	def on_b_refresh_clicked(self, widget):
		self.refresh_connections()
		
	def on_b_kill_clicked(self, widget):
		rowid = self.conn_list.get_cursor()
		iter = self.liststore.get_iter_from_string(str(rowid[0][0]))
		addr = self.liststore.get_value(iter,0)
		
		PAN.kill_connection(addr)
		time.sleep(0.2)
		num = self.refresh_connections()
		if num == 0 and PAN.role == "PANU":
			self.enable_all()
			self.b_stop.set_sensitive(False)
			self.l_daemon.set_markup(_("<b>Inactive</b>"))
			
			
	def on_b_killall_clicked(self, widget):
		PAN.kill_all_connections()
		time.sleep(0.2)
		num = self.refresh_connections()
		if num == 0 and PAN.role == "PANU":
			self.enable_all()
			self.b_stop.set_sensitive(False)
			self.l_daemon.set_markup(_("<b>Inactive</b>"))
	
	def disable_controls(self):
		
		self.l_ifup.set_sensitive(False)
		self.e_ifup.set_sensitive(False)
		
		self.cb_auto_start.set_sensitive(False)
		
		self.e_interface.set_sensitive(False)
		
		self.b_start.set_sensitive(False)
		
		self.rb_nap.set_sensitive(False)
		self.rb_gn.set_sensitive(False)
		self.rb_panu.set_sensitive(False)
		
		self.cb_encrypt.set_sensitive(False)
		self.cb_auth.set_sensitive(False)
		self.cb_security.set_sensitive(False)
		
		self.l_ifdown.set_sensitive(False)
		self.e_ifdown.set_sensitive(False)
		self.l_interface.set_sensitive(False)
		
	def enable_all(self):
	
		self.l_ifup.set_sensitive(True)
		self.e_ifup.set_sensitive(True)
		
		self.cb_auto_start.set_sensitive(True)
		
		self.e_interface.set_sensitive(True)
		
		self.b_start.set_sensitive(True)
		
		self.rb_nap.set_sensitive(True)
		self.rb_gn.set_sensitive(True)
		self.rb_panu.set_sensitive(True)
		
		self.cb_encrypt.set_sensitive(True)
		self.cb_auth.set_sensitive(True)
		self.cb_security.set_sensitive(True)
		
		self.l_ifdown.set_sensitive(True)
		self.e_ifdown.set_sensitive(True)
		self.l_interface.set_sensitive(True)
		

class obex:
	
	def __init__(self):
		
		self.xml = gtk.glade.XML(GLADE_DIR + "/obex.glade")
		self.dialog = self.xml.get_widget("obex")
		self.cb_startup = self.xml.get_widget("cb_startup")
		self.b_start = self.xml.get_widget("b_start")
		self.b_stop = self.xml.get_widget("b_stop")
		self.l_status = self.xml.get_widget("l_status")
		self.xml.signal_autoconnect(self)
		
		
		if OBEX.autostart:
			self.cb_startup.set_active(True)
			
		if OBEX.status():
			self.b_start.set_sensitive(False)
			self.l_status.set_markup(_("<b>Active</b>"))
		else:
			self.b_stop.set_sensitive(False)
			
		self.dialog.run()
		self.dialog.destroy()
		
		
	def on_start_clicked(self, widget):
		OBEX.start()
		self.b_stop.set_sensitive(True)
		self.b_start.set_sensitive(False)
		self.l_status.set_markup(_("<b>Active</b>"))
		
	def on_stop_clicked(self, widget):
		OBEX.stop()
		self.b_stop.set_sensitive(False)
		self.b_start.set_sensitive(True)
		self.l_status.set_markup(_("<b>Inactive</b>"))
		
	def on_cb_startup_toggled(self, widget):
		if widget.get_active():
			OBEX.autostart = True
			OBEX.save_settings()
		else:
			OBEX.autostart = False
			OBEX.save_settings()
			
class sco:
	
	def __init__(self):
		self.sco = bt.sco()
		
		self.xml = gtk.glade.XML(GLADE_DIR + "/sco.glade")
		
		self.dialog = self.xml.get_widget("sco")
		self.e_device = self.xml.get_widget("e_device")
		self.l_status = self.xml.get_widget("l_status")
		self.b_connect = self.xml.get_widget("b_connect")
		self.b_disconnect = self.xml.get_widget("b_disconnect")
		self.b_prefs = self.xml.get_widget("b_prefs")
		
		icon = gtk.gdk.pixbuf_new_from_file_at_size(IMAGE_DIR + "/devices/handsfree.png",16, 16)
		self.dialog.set_icon(icon)
		

			
		if self.sco.status():
			self.b_connect.set_sensitive(False)
			self.b_disconnect.set_sensitive(True)
			self.e_device.set_sensitive(False)
			self.l_status.set_markup(_("<b>Active</b>"))
		else:
			self.b_disconnect.set_sensitive(False)
			self.b_connect.set_sensitive(True)
			
		addr = main_list.get_selected_row()
		if addr:
			self.e_device.set_text(addr[0])
		else:
			self.b_connect.set_sensitive(False)
			
		self.xml.signal_autoconnect(self)
		self.dialog.run()
		self.dialog.destroy()
			
	def on_e_device_changed(self, widget):
		if not adapter.is_valid_address(widget.get_text()):
			self.b_connect.set_sensitive(False)
		else:
			self.b_connect.set_sensitive(True)
			
	def on_b_connect_clicked(self, widget):
		self.sco.start(self.e_device.get_text())
		time.sleep(0.2)
		if self.sco.status():
			self.b_connect.set_sensitive(False)
			self.b_disconnect.set_sensitive(True)
			self.e_device.set_sensitive(False)
			self.l_status.set_markup(_("<b>Active</b>"))
		else:
			self.b_connect.set_sensitive(True)
			self.b_disconnect.set_sensitive(False)
			self.e_device.set_sensitive(True)
			self.l_status.set_markup(_("<b>Unknown error</b>"))
		
	def on_b_disconnect_clicked(self, widget):
		self.sco.stop()
		self.b_connect.set_sensitive(True)
		self.b_disconnect.set_sensitive(False)
		self.e_device.set_sensitive(True)
		self.l_status.set_markup(_("<b>Inactive</b>"))
		
